#include <stdio.h>
#include <set>

using namespace std;

#define NMAX 1000100

#define min(a,b) ((a) <= (b) ? (a) : (b))
#define max(a,b) ((a) >= (b) ? (a) : (b))

//#define PRINT_DEBUG_INFO
#define LMIN 2
#define LMAX 2

set<pair<int, pair<int, int> > > side_length;
set<pair<int, pair<int, int> > >::iterator it;
int N, nsol, i, ja, jb;
int num_repeated[7], slen[7];

void read_input() {
	freopen("equicover.in", "r", stdin);
	scanf("%d", &N);
}

void generate() {
	int k, l, sum, left, start_len, end_len, current_len, left2, left2limit, k2, li, ls, mid;
	for (start_len = 1; start_len <= N; start_len += 2) {
		for (k = 1; 1; k++) {
			sum = start_len * k + k * (k - 1);
			left = N - sum;
			if (left < 0)
				break;
			else if (left == 0) {
				slen[0] = start_len;
				slen[1] = 2 * k ;
				if (start_len == 1)
					slen[1]--;
				slen[2] = 1;
				slen[3] = start_len + 2 * (k - 1);
				slen[4] = 1;
				slen[5] = slen[1];
					
				side_length.clear();
				for (i = 0; i <= 5; i++) {
					pair<int, int> vec;
					ja = (i + 5) % 6;
					while (slen[ja] % 2 == 0)
						ja = (ja + 5) % 6;
					jb = (i + 1) % 6;
					while (slen[jb] % 2 == 0)
						jb = (jb + 1) % 6;
					vec.first = min(slen[ja], slen[jb]);
					vec.second = max(slen[ja], slen[jb]);
					if (slen[i] % 2 == 1)
						side_length.insert(make_pair(slen[i], vec));
				}
				num_repeated[side_length.size()]++;
				if (k > 1)
					num_repeated[side_length.size()]++;
						
				#ifdef PRINT_DEBUG_INFO
				if (side_length.size() >= LMIN && side_length.size() <= LMAX) {
					fprintf(stderr, "### sol: start_len=%d, k=%d\n", start_len, k);
					fprintf(stderr, "side_length.size()=%d: ", side_length.size());
					for (it = side_length.begin(); it != side_length.end(); it++)
						fprintf(stderr, "%d ", it->first);
					fprintf(stderr, "\n");
					fprintf(stderr, "slen:");
					for (i = 0; i <= 5; i++)
						fprintf(stderr, " %d", slen[i]);
					fprintf(stderr, "\n");
				}
				#endif
			} else { // left > 0
				current_len = start_len + 2 * (k - 1);
				left2limit = (current_len + 1) / 2;
				if (left / left2limit < left2limit)
					left2limit = left;
				else
					left2limit *= left2limit;

				for (l = left / (current_len + 1); l >= 0; l--) {
					left2 = left - l * (current_len + 1);
					if (left2 > left2limit)
						break;
					if (left2 == 0) {
						slen[0] = start_len;
						slen[1] = 2 * k + 1;
						if (start_len == 1)
							slen[1]--;
						slen[2] = 2 * l + 1;
						slen[3] = current_len + 1;
						slen[4] = 1;
						slen[5] = 2 * (l + k);
						if (start_len == 1)
							slen[5]--;
						
						side_length.clear();
						for (i = 0; i <= 5; i++) {
							pair<int, int> vec;
							ja = (i + 5) % 6;
							while (slen[ja] % 2 == 0)
								ja = (ja + 5) % 6;
							jb = (i + 1) % 6;
							while (slen[jb] % 2 == 0)
								jb = (jb + 1) % 6;
							vec.first = min(slen[ja], slen[jb]);
							vec.second = max(slen[ja], slen[jb]);
							if (slen[i] % 2 == 1)
								side_length.insert(make_pair(slen[i], vec));
						}
						num_repeated[side_length.size()]++;
						
						#ifdef PRINT_DEBUG_INFO
						if (side_length.size() >= LMIN && side_length.size() <= LMAX) {
							fprintf(stderr, "### sol: start_len=%d, k=%d, increasing + pare - len=%d, l=%d\n", start_len, k, current_len + 1, l);
							fprintf(stderr, "side_length.size()=%d: ", side_length.size());
							for (it = side_length.begin(); it != side_length.end(); it++)
								fprintf(stderr, "%d ", it->first);
							fprintf(stderr, "\n");
							fprintf(stderr, "slen:");
							for (i = 0; i <= 5; i++)
								fprintf(stderr, " %d", slen[i]);
							fprintf(stderr, "\n");
						}
						#endif
					} else { // left2 > 0						
						li = 1; k2 = -1;

						ls = 1;
						while ((ls < ((current_len + 1) / 2)) && (current_len * ls - ls * (ls - 1)) < left2)
							ls *= 2;
						if (ls > ((current_len + 1) / 2))
							ls = (current_len + 1) / 2;
					
						while (li <= ls) {
							mid = (li + ls) / 2;
							sum = current_len * mid - mid * (mid - 1);
							if (sum == left2) {
								k2 = mid;
								break;
							} else if (sum < left2) {
								li = mid + 1;
							} else { // sum > left2
								ls = mid - 1;
							}
						}
						
						if (k2 > 0) {
							end_len = current_len - 2 * (k2 - 1);
							slen[0] = start_len;
							slen[1] = 2 * k + 1;
							if (start_len == 1)
								slen[1]--;
							slen[2] = 2 * (l + k2) + 1;
							if (end_len == 1)
								slen[2]--;
							slen[3] = end_len;
							slen[4] = 2 * k2 + 1;
							if (end_len == 1)
								slen[4]--;
							slen[5] = 2 * (l + k) + 1;
							if (start_len == 1)
								slen[5]--;
							
							side_length.clear();
							for (i = 0; i <= 5; i++) {
								pair<int, int> vec;
								ja = (i + 5) % 6;
								while (slen[ja] % 2 == 0)
									ja = (ja + 5) % 6;
								jb = (i + 1) % 6;
								while (slen[jb] % 2 == 0)
									jb = (jb + 1) % 6;
								vec.first = min(slen[ja], slen[jb]);
								vec.second = max(slen[ja], slen[jb]);
								if (slen[i] % 2 == 1)
									side_length.insert(make_pair(slen[i], vec));
							}
							num_repeated[side_length.size()]++;

							#ifdef PRINT_DEBUG_INFO
							if (side_length.size() >= LMIN && side_length.size() <= LMAX) {
								fprintf(stderr, "### sol: start_len=%d, k=%d, increasing + pare - len=%d, l=%d + impare - start_len=%d, k2=%d, decreasing\n", start_len, k, current_len + 1, l, current_len, k2);
								fprintf(stderr, "side_length.size()=%d: ", side_length.size());
								for (it = side_length.begin(); it != side_length.end(); it++)
									fprintf(stderr, "%d ", it->first);
								fprintf(stderr, "\n");
								fprintf(stderr, "slen:");
								for (i = 0; i <= 5; i++)
									fprintf(stderr, " %d", slen[i]);
								fprintf(stderr, "\n");
							}
							#endif
						}
					}
				}
			}
		}
	}
}

void compute() {
	generate();
	for (nsol = 0, i = 1; i <= 6; i++) {
		nsol += (num_repeated[i] / i);
		if (num_repeated[i] % i > 0) {
			fprintf(stderr, "wtf? i=%d\n", i);
		}
	}
}

void write_output() {
	freopen("equicover.out", "w", stdout);
	printf("%d\n", nsol);
	fprintf(stderr, "N=%d, total: %d, rep1=%d, rep2=%d, rep3=%d, rep4=%d, rep5=%d, rep6=%d\n", N, nsol, num_repeated[1], num_repeated[2], num_repeated[3], num_repeated[4], num_repeated[5], num_repeated[6]);
}

int main() {
	read_input();
	compute();
	write_output();
	return 0;
}
