// Mugurel Ionut Andreica - O(N*log(N))

#include <stdio.h>
#include <algorithm>
#include <vector>
#include <set>
#include <map>

using namespace std;

#define NMAX 131072

#define max(a, b) ((a) >= (b) ? (a) : (b))

vector<pair<int, int> > p;
set<int> ycoord;
set<int>::iterator it;
map<int, int> ycoord_map;
int v[NMAX << 1];
int N;

void read_input() {
	int i, x, y, a, b;
	freopen("linii.in", "r", stdin);
	scanf("%d", &N);
	for (i = 1; i <= N; i++) {
		scanf("%d %d", &x, &y);
		a = x + y;
		b = y - x;
		p.push_back(make_pair(a, b));
		ycoord.insert(b);
	}
}

int query(int a) {
	int b = NMAX + a - 1, result = 0;
	while (b > 1) {
		if ((b & 1) == 1) {
			// b is the right son of its parent.
			result = max(result, v[b - 1]);
		}
		b = b >> 1;
	}
	return result;
}

void update(int a, int val) {
	int b = NMAX + a - 1;
	while (b >= 1) {
		v[b] = max(v[b], val);
		b = b >> 1;
	}
}

void compute() {
	int i, j, M, lmax;
	for (M = 0, it = ycoord.begin(); it != ycoord.end(); it++) {
		M++;
		ycoord_map[*it] = M;
	}

	sort(p.begin(), p.end());
	for (i = p.size() - 1; i >= 0; i--) {
		j = ycoord_map[p[i].second];
		lmax = query(j);
		lmax++;
		//fprintf(stderr, "(%d,%d): lmax=%d\n", p[i].first, p[i].second, lmax);
		update(j, lmax);
	}
}

void write_output() {
	freopen("linii.out", "w", stdout);
	printf("%d\n", v[1]);
	fprintf(stderr, "result=%d\n", v[1]);
}

int main() {
	read_input();
	compute();
	write_output();
}
