// Dragos Oprica
// Complexitate : O(N x log N)

#include <algorithm>
#include <fstream>
using namespace std;

ifstream fin ("permsort.in");
ofstream fout ("permsort.out");

#define DIM 1000005

int pozV[DIM],aib[DIM];
long long retS;
int N;

inline int lsb (int x) {

  return x&(-x);
}

inline void update (int poz,int val) {

  for ( ; poz<=N; poz+=lsb (poz))
    aib[poz]+=val;
}

void read () {
  int i,x;

  fin>>N;
  for (i=1; i<=N; ++i) {

    fin>>x;
    pozV[x]=i;
    update (pozV[x],1);
  }
}

inline int query (int pozA,int pozB) {
  int ret;

  for (ret=0; pozB>=1; pozB-=lsb (pozB))
    ret+=aib[pozB];
  for (--pozA; pozA>=1; pozA-=lsb (pozA))
    ret-=aib[pozA];

  return ret;
}

void solve () {
  int i;

  retS=pozV[1];
  update (pozV[1],-1);

  for (i=2; i<=N; ++i) {

    if (pozV[i-1]<pozV[i])
      retS+=query (pozV[i-1],pozV[i]);
    else
      retS+=(N-i+1)-query (pozV[i],pozV[i-1])+1;

    update (pozV[i],-1);
  }

  fout<<retS;
}

int main () {

  read ();
  solve ();

  return 0;
}
