// Dragos Oprica
// Complexitate : O(N x log N)

#include <algorithm>
#include <fstream>
using namespace std;

ifstream fin ("permsort.in");
ofstream fout ("permsort.out");

#define DIM 1000005

int pozV[DIM],aint[DIM<<2];
long long retS;
int N;

void read () {
  int i,x;

  fin>>N;
  for (i=1; i<=N; ++i) {

    fin>>x;
    pozV[x]=i;
  }
}

void build_aint (int nod,int st,int dr) {
  int mij;

  if (st==dr)
    aint[nod]=1;
  else {
    mij=(st+dr)>>1;

    build_aint (nod<<1,st,mij);
    build_aint ((nod<<1)|1,mij+1,dr);

    aint[nod]=aint[nod<<1]+aint[(nod<<1)|1];
  }
}

int query (int nod,int st,int dr,int in,int sf) {
  int mij,ret;

  if (in<=st && dr<=sf)
    return aint[nod];
  else {
    mij=(st+dr)>>1; ret=0;

    if (in<=mij)
      ret+=query (nod<<1,st,mij,in,sf);
    if (mij<sf)
      ret+=query ((nod<<1)|1,mij+1,dr,in,sf);
  }

  return ret;
}

void update (int nod,int st,int dr,int poz) {
  int mij;

  if (st==dr)
    aint[nod]=0;
  else {

    mij=(st+dr)>>1;

    if (poz<=mij)
      update (nod<<1,st,mij,poz);
    else
      update ((nod<<1)|1,mij+1,dr,poz);

    aint[nod]=aint[nod<<1]+aint[(nod<<1)|1];
  }
}

void solve () {
  int i;

  build_aint (1,1,N);

  retS=pozV[1];
  update (1,1,N,pozV[1]);
  for (i=2; i<=N; ++i) {

    if (pozV[i-1]<pozV[i])
      retS+=query (1,1,N,pozV[i-1],pozV[i]);
    else
      retS+=(N-i+1)-query (1,1,N,pozV[i],pozV[i-1])+1;

    update (1,1,N,pozV[i]);
  }

  fout<<retS;
}

int main () {

  read ();
  solve ();

  return 0;
}
